# -*- coding: utf-8 -*-
"""
Created on Wed Dec 10 11:13:13 2013

@author: bercherj
"""


from __future__ import division
from __future__ import print_function

from pylab import *
from scipy import signal
from numpy.fft import fft, ifft 



# Implantation utilisant le type array
def algo_mcr(u,d,M,plambda):
    N=size(u)
# initialisation
    e=zeros(N)
    wmcr=zeros((M,N+1))
    Kmcr=100*eye(M)
    u_v=zeros(M)
    for n in range(N):
        u_v[0]=u[n]
        u_v[1:M]=u_v[0:M-1]#concatenate((u[n], u_v[1:M]), axis=0)
        e[n]=conj(d[n])-dot(conj(u_v),wmcr[:,n])
        # print("n={}, Erreur de {}".format(n,e[n]))
        Kn=Kmcr/plambda
        Kmcr=Kn-dot(Kn,dot(outer(u_v,conj(u_v)),Kn))/(1+dot(conj(u_v),dot(Kn,u_v)))
        wmcr[:,n+1]=wmcr[:,n]+dot(Kmcr,u_v)*conj(e[n])
    return (wmcr,e)

## MCR, version matricielle
# C'est plus léger qu'avec tous les dot et outer...
def col(v):
     """ transforme un array en vecteur colonne \n
     l'équivalent du x=x(:) sous Matlab"""
     v=asmatrix(v.flatten())
     return reshape(v,(size(v),1))
    
def algo_mcr_m(u,d,M,plambda):
    """
    Implantation avec le type matrix plutot que array
    """
    N=size(u)
	# initialisation
    e=zeros(N)
    wmcr=matrix(zeros((M,N+1)))
    Kmcr=100*matrix(eye(M))
    u=col(u)
    u_v=matrix(col(zeros(M)))
        
    for n in range(N):
        u_v[0]=u[n]
        u_v[1:M]=u_v[0:M-1]
		#u_v=concatenate(u[n], u_v[:M], axis=0)
        e[n]=conj(d[n])-u_v.H*wmcr[:,n]
        Kn=Kmcr/plambda
        Kmcr=Kn-Kn*(u_v*u_v.H*Kn)/(1+u_v.H*Kn*u_v)
        wmcr[:,n+1]=wmcr[:,n]+Kmcr*u_v*conj(e[n])
      
    return (wmcr,e)
    
def sysfileopen(filepath):
    import subprocess, os
    if sys.platform.startswith('darwin'):
        subprocess.call(('open', filepath))
    elif os.name == 'nt':
            os.startfile(filepath)
    elif os.name == 'posix':
#            subprocess.call(('xdg-open', filepath))
            subprocess.Popen(["xdg-open", filepath])

# Import useful read-write for wav files
from scipy.io.wavfile import read as wavread, write as wavwrite


# En fait ce n'est pas simple du tout de jouer un son sous python... Il y a bien 
# des librairies, mais ce n'est pas direct. Ce n'est pas forcément plus simple 
# sous Matlab d'ailleurs où ce qui fonctionne sous Zin ne fonctionne pas sous Linux
#
# ici je prends le parti suivant : écrire un fichier wav temporaire, et le jouer 
# avec l'application par défaut du système. C'est robuste.
def sound(var):
    from scipy.io.wavfile import write as wavwrite
    scaled = np.int16(var/np.max(np.abs(var)) * 32767)
    stmp=asarray(scaled,dtype=np.int16)
    wavwrite('stmp.wav',8820,stmp)
    sysfileopen("stmp.wav")